--if vim.fn.exists(":PylspInstall") then
--  vim.cmd("PylspInstall pylsp-mypy")
--end
-- https://github.com/williamboman/mason.nvim/discussions/908
local pylsp = require("mason-registry").get_package("python-lsp-server")
pylsp:on("install:success", function ()
  local mason_package_path = function(package)
    local path = vim.fn.resolve(vim.fn.stdpath("data") .. "/mason/packages/" .. package)
    return path
  end

  local path = mason_package_path("python-lsp-server")
  local command = path .. "/venv/bin/python"

  local install_cmd = { command, "-m", "pip", "install" }
  local pylsp_plugins = { "python-lsp-ruff", "pylsp-mypy" }
  vim.schedule(function()
    vim.fn.system(vim.list_extend(install_cmd, pylsp_plugins))
  end)

  local flake8_plugins = { "flake8-pyproject", "flake8-pylint" }
  vim.schedule(function()
    vim.fn.system(vim.list_extend(install_cmd, flake8_plugins))
  end)
end)

local opts = {}
opts.pylsp = require("lsp.server_settings.pylsp")
opts.hls = require("lsp.server_settings.hls")
opts.fortls = require("lsp.server_settings.fortls")

local workspace_conf_file = vim.fn.findfile(".nvim/lsp-server-conf.lua", ".;")
if workspace_conf_file ~= "" then
    local workspace_conf = dofile(workspace_conf_file)
    opts = vim.tbl_deep_extend("force", opts, workspace_conf)
end

return opts
